=== debian/changelog ===
freeorion (0.4.3+svn7114-2) unstable; urgency=medium

  * Upload to unstable.
  * FreeOrion depends on Ogre 1.9 now. (Closes: #732721)
  * Fix dpkg-shlibdeps warning.
     - Update the LD_LIBRARY_PATH variable again.
  * Remove WEAK_HOSTS conditionals.
     - Build with default values on all arches again since FreeOrion is now
       able to build on armel, armhf and mips. If this proves not to be
       successful, compiling with MinSizeRel is still an alternative.
  * Install ogre_plugins.cfg with arch-dependent package.
     - ogre_plugins.cfg must be installed with the arch-dependent package
       otherwise the game won't start for all architectures except the one
       that built the -data package.
  * Use dh_install --fail-missing to detect uninstalled files.

 -- Markus Koschany <apo@gambaru.de>  Sun, 11 May 2014 19:27:11 +0200

freeorion (0.4.3+svn7114-1) experimental; urgency=medium

  [ Dmitry Smirnov ]
  * Removed myself from Uploaders.

  [ Markus Koschany ]
  * New upstream snapshot.
  * Remove powerpc64, sparc64, sh4, x32, powerpcspe, arm64 and hppa from
    WEAK_HOSTS.
    - These hosts should be able to compile freeorion with RelWithDebInfo.
  * Update get-orig-source target for r7114.
  * Drop the following patches. They were merged upstream.
    - omit-ADOBE_NO_DOCUMENTATION-check.patch
    - omit-endianness-and-size-checks.patch
  * Update freeorion.install for new release.
  * Update freeorion-data.install for new release.
  * Remove subversion from Build-Depends to reduce the probability of build
    failures.
  * Use icons provided by upstream:
    - Do not convert FreeOrion.ico anymore.
    - Convert only the 32x32 icon to the xpm format due to compatibility reasons
      with older window managers.
  * wrap-and-sort -sa.
  * Switch to Ogre 1.9.
  * debian/rules:
    - Update LD_LIBRARY_PATH for new release.
    - Set CMAKE_VERBOSE_MAKEFILE=ON.
    - Use -S option of dpkg-parsechangelog. Build-Depend on dpkg-dev (>= 1.17).
  * Update freeorion wrapper script.
    - Adjust the path to OISInput.cfg.
    - Create ~/.freeorion on first start.
  * Update version-string.patch.
  * Add GG-verbose-makefile.patch again and increase verbosity when building GG.
  * Update freeorion.6 man page for new release.
  * Add Forwarded header to remaining patches.
  * Update copyright years.

 -- Markus Koschany <apo@gambaru.de>  Wed, 07 May 2014 23:16:16 +0200

freeorion (0.4.3-3) unstable; urgency=medium

  * debian/rules:
    - Remove s390 from WEAK hosts. It is obsolete.
    - Change optimization for WEAK hosts to MinSizeRel.
      This change tries to achieve that the build stops failing on arches such
      as armel, armhf, mips and mipsel by using less optimization. (-Os)
  * Update Standards-Version to 3.9.5, no changes.
  * Add OISInput-config.patch and copy OISInput.cfg from
    /usr/share/games/freeorion to $HOME/.freeorion. Provide an easy way to
    modify OISInput.cfg for normal users and allow them to adjust the settings
    for mouse and keyboard behaviour. (Closes: #719496)
  * Use a stricter dependency for the data package.
    - Apparently it makes no difference if a >= <= relation or just =
      is used for the data package.
  * Update copyright years.
  * Remove source/options. xz compression is the default now.

 -- Markus Koschany <apo@gambaru.de>  Wed, 26 Mar 2014 07:41:32 +0100
